#include <vector>
#include<iostream>
#include<stdlib.h>
#include "Initialize.h"
#include "xmlParser.h"
#include"main.h"
using namespace std;

extern int optind;
extern int optopt;
extern char *optarg;
#define DEFAULT_THREAD_NUM 10
int getopt(int argc, char * const *argv, const char *optstring);

Initialize::Initialize(int argc, char *argv[]) : exec_flag(0), config_file_name("confxml.xml"), sync_num(0), module("sersync")
{
	ConfigInotify( ); //modify system param
	CammandParse( argc, argv ); //parse command param
	XmlParse( );
}

int Initialize::XmlParse()
{
	cout << "解析配置文件" << endl;
	XMLNode xMainNode = XMLNode::openFileHelper( config_file_name.c_str( ), "head" );
	XMLNode xNode = xMainNode.getChildNode( "host" );

	hostip = xNode.getAttribute( "hostip" );
	cout << "当前主机ip为: " << hostip << "\t";

	port = atoi( xNode.getAttribute( "port" ) );
	cout << "当前主机端口为" << port << endl;

}

int Initialize::CammandParse(int argc, char* argv[])
{
	optarg = NULL;
	string temp;
	int ch;
	cout << "解析命令行参数" << endl;
	while ((ch = getopt( argc, argv, "hdro:n:m:" )) != -1)
	{

		switch (ch)
		{
			case 'd':
				printf( "选项: -d \t" );
				printf( "以守护进程运行\n" );
				exec_flag |= OPEN_DAEMON;
				break;
			case 'r':
				printf( "选项: -r \t" );
				printf( "在运行程序前对目标服务器统一推送一次\n" );
				exec_flag |= RSYNC_ONCE;
				break;
			case 'o':
				printf( "选项: -o \t" );
				printf( "配置文件名为：  %s\n", optarg );
				config_file_name = optarg;
				if (config_file_name.empty( ))
				{
					cout << "ERROR 文件名不能为空" << endl;
					exit( 1 );
				}
				exec_flag |= OTHER_CONFNAME;
				break;
			case 'm':
				printf( "选项: -m \t" );
				printf( "运行功能模块名称是: %s\n", optarg );
				module = "other";
				temp = optarg;
				if (temp == "sersync")
				{
					exec_flag |= SERSYNC_MODULE;
				}
				if (temp == "refreshCDN")
				{
					exec_flag |= REFRESHCDN_MODULE;
				}
				if (temp == "socket")
				{
					exec_flag |= SOCKET_MODULE;
				}
				if (temp == "http")
				{
					exec_flag |= HTTP_MODULE;
				}
				break;
			case 'h':
				cout << "_______________________________________________________" << endl;
				cout << "参数-d:启用守护进程模式" << endl;
				cout << "参数-r:在监控前，将监控目录与远程主机用rsync命令推送一遍" << endl;
				cout << "c参数-n: 指定开启守护线程的数量，默认为10个" << endl;
				cout << "参数-o:指定配置文件，默认使用confxml.xml文件" << endl;
				cout << "参数-m:启用其他模块，使用 -m refreshCDN 开启刷新CDN模块" << endl;
				cout << "参数-m:启用其他模块，使用 -m socket 开启socket模块" << endl;
				cout << "参数-m:启用其他模块，使用 -m http 开启http模块" << endl;
				cout << "不加-m参数，则默认执行同步程序" << endl;
				cout << "________________________________________________________________" << endl;
				exit( 0 );
			case 'n':
				printf( "选项: -n \t" );
				printf( "同步线程数为：  %s\n", optarg );
				sync_num = atoi( optarg );
				exec_flag |= SYN_NUM;
				break;
			case '?':
				printf( "命令行参数错误: 没有该选项-%c\n", (char) optopt );
				exit( 1 );
		}
	}//end while
	if (sync_num == 0)
	{
		sync_num = DEFAULT_THREAD_NUM;
		cout << "同步守护线程数: " << DEFAULT_THREAD_NUM << endl;
	}
}

void Initialize::ConfigInotify()
{
	cout << "对系统参数进行配置" << endl;
	cout << "执行命令：echo 50000000 > /proc/sys/fs/inotify/max_user_watches" << endl;
	system( "echo 50000000 > /proc/sys/fs/inotify/max_user_watches" );
	cout << "执行命令：echo 327679 > /proc/sys/fs/inotify/max_queued_events" << endl;
	system( "echo 327679 > /proc/sys/fs/inotify/max_queued_events" );

}

string Initialize::SplitLastSlash(string str)
{
	if (str.empty( ))
	{
		perror( "监控路径不能为空" );
		exit( 1 );
	}
	if (str.find_last_of( "/" ) == (str.length( ) - 1))
	{
		str = str.substr( 0, str.length( ) - 1 );
	}
	return str;
}

