#include <string>
#include<iostream>
#include <sys/inotify.h>
#include <boost/shared_ptr.hpp>
#include <deque>
#include <map>
#include"QueueFilter.h"
#ifndef _INOTIFY_H
#define _INOTIFY_H
//需要监控的事件
#define IN_SYNC (IN_CREATE | IN_DELETE | IN_MOVED_FROM | IN_MOVED_TO | IN_CLOSE_WRITE) //wide off the IN_ATTRIB IN_MODIFY|

struct InotifyEvent {
    int wd; //watch descriptor for the function named  inotify_add_watch
    std::string path;
    bool dir; // true if is dir;
    int mask; // event mask  response to IN_SYNC
    int operation; // create/delete = 1/0
};

typedef std::map<int, std::string> PathMap;
typedef std::pair<int, std::string> PathPair;
typedef boost::shared_ptr<InotifyEvent> Event;

/**
 * Inotify 提供对指定目录的完整递归监控及对监控的管理。
 *
 */
class Inotify {
protected:
    PathMap m_path; // source under watching
    int m_fd; //watch resource identifier
public:
    Inotify(std::string rootPath); //add root path which want to watch
    bool addWatch(std::string path);
    bool removeWatch(std::string path); //remove watch path
    unsigned int getEvents(ptrQFilter que);
protected:
    int filterEvent(inotify_event* event); //filt redundant or error event
    int fillEvent(inotify_event* event, ptrQFilter que);
private:
    bool ReadFill(ptrQFilter que);
};
#endif
